#ifndef AREA_H
#define AREA_H

#include <iostream>
#include <string>
#include <vector>
#include <fstream>
#include <cstdio>

#include "json/json.h"

#include "merkator.h"
#include "point.h"
#include "data.h"
class Area : public Data
{
    public:
        Area(Json::Value& v);
        Area(Way& v);
        Area();
		void set(Json::Value& v);
        Json::Value getJson(bool b=false);
        virtual ~Area();
		const Area& operator=(const Area& a)
		{
			m_name = a.m_name;
			m_coord = a.m_coord;
			m_resource = a.m_resource;
			m_points = a.m_points;
			return a;
		}
        const std::string& getName();
        void  addPoint(Point& p);

			
        std::string m_name;
        Json::Value m_coord;
        std::string m_resource;
        std::vector<Point> m_points;
		static Area& 	cast(Data& d);

    protected:

    private:
};

#endif // AREA_H
