/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-  */
/*
 * g-window.h
 * Copyright (C) 2017 Unknown <francois@gautrais.eu>
 *
 * histodexc is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * histodexc is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _G_WINDOW_H_
#define _G_WINDOW_H_


class GeneralTab;
class ResourceTab;
class ZoneTab;
class StageTab;
struct _Private;
class GWindow
{
	public:
		GWindow();
		virtual ~GWindow();

		virtual void show();
		void write(const std::string& file);
		Json::Value getJson(bool genFinal=false);
		void on_generate();
		void on_new();
		void on_import();
		void on_open();
		void on_save();
		void on_saveas();
		void on_exit();
		void open(const std::string& f);
		void changeFile(const std::string& file);
		 
		
	protected:
		int				m_magic;
		GtkWidget		*m_window;
		GtkBuilder		*m_builder;
		struct _Private *m_priv;

		GtkButton* m_generate;
		GtkImageMenuItem* m_new;
		GtkMenuItem*		m_import;
		GtkImageMenuItem* m_open;
		GtkImageMenuItem* m_save;
		GtkImageMenuItem* m_saveas;
		GtkImageMenuItem* m_exit;
		GtkTextView*		m_log;
		

		GeneralTab		*m_general;
		ResourceTab		*m_resource;
		ZoneTab			*m_zone;
		StageTab		*m_stage;
		std::string     m_currentFile;
	protected:
		void init_menu();
		void setModidified();

		void clearModidified();
		bool isModidified();
		bool checkSaved();
		 
	private:

};



extern "C" {
extern void window_start(int argc, char** argv); /* a C function */
}

#endif // _G_WINDOW_H_

