/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-  */
/*
 * general-tab.h
 * Copyright (C) 2017 Unknown <francois@gautrais.eu>
 *
 * histodexc is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * histodexc is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _GENERAL_TAB_H_
#define _GENERAL_TAB_H_

#include "tab.h"
#include "general.h"
class StageTab;
class GeneralTab : public Tab 
{
public:
							GeneralTab(GtkWidget *window, GtkBuilder *builder, StageTab* st);
	virtual					~GeneralTab();
	virtual void			write(const std::string& file);
	virtual Json::Value		getJson(bool genFinal=false);
	virtual void			open(Json::Value& val);
	virtual void			on_save_clicked();	 
    int						on_stage_changed();	 
	virtual void			setupTab(Data& a);
	virtual void			setLayout ();
	virtual Data&			getTab(bool& genFinal);
	General					getGeneral(){ bool b; return General::cast(getTab(b));}
	 
protected:
	GtkEntry*				m_name;
	GtkSpinButton*			m_stages;
	GtkFileChooserButton*	m_dir;
	GtkFileChooserButton*	m_map;
	GtkSwitch*				m_useMap;
	StageTab*				m_stage;
	
};

#endif // _GENERAL_TAB_H_

