/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-  */
/*
 * general.h
 * Copyright (C) 2016 Unknown <francois@gautrais.eu>
 *
 * histodex is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * histodex is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _GENERAL_H_
#define _GENERAL_H_

#include <iostream>
#include "data.h"
#include <json/json.h>
class GeneralTab;
class Generator;

class General : public Data
{
public:
					General(Json::Value& v);
					General();
	virtual			~General();
	const Data&		operator=(const General& a);
	Json::Value		getJson(bool genFinal=false);
	void			set(Json::Value& v);
	const std::string& 
					getMap();
	static General& cast(Data& d);
	 
protected:
	std::string		m_name;
	std::string		m_dir;
	int				m_nStages;
	std::string		m_map;

	 friend class GeneralTab;
	 friend class Generator;
};

#endif // _GENERAL_H_

