/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-  */
/*
 * image-obj.h
 * Copyright (C) 2016 Fran??ois Gautrais <francois@gautrais.eu>
 *
 * histodex is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * histodex is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _IMAGE_OBJ_H_
#define _IMAGE_OBJ_H_

#include <iostream>
#include <string>
class Generator;
class ImageObj
{
	public:
		ImageObj(const std::string& image, const std::string& dir, const std::string& name, Generator* g);
		virtual ~ImageObj();

		void generate();
		 
	protected:
		std::string m_name;
		std::string m_image;
		std::string m_dir;
		std::string m_texture;
		std::string m_obj;
		std::string m_mtl;
		std::string m_image_out; 
		std::string m_dir_raw; 
		std::string m_dir_drawable;
		Generator* m_gen;

	protected:
		void generateObj();
		void generateMtl();
		void generateTexture();
		void generateImage();
	private:

};

#endif // _IMAGE_OBJ_H_

