/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-  */
/*
 * map-viewer.h
 * Copyright (C) 2016 Fran??ois Gautrais <francois@gautrais.eu>
 *
 * histodex is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * histodex is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _MAP_VIEWER_H_
#define _MAP_VIEWER_H_

#include <glib.h>
#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include <iostream>
#include <vector>
#include <gtk/gtk.h>
#include "osm-gps-map.h"

#include <json/json.h>
class ZoneTab;
class MapViewer
{
public:
	MapViewer(GtkBox* box, GtkSpinButton * sb, ZoneTab* zt);
	virtual ~MapViewer();

	 
	void add_point_to_poly(float lat, float lon);
	void set_place(float lat, float lon);
	void new_poly();
	void new_place();
	Json::Value getPlace() { return m_place; }
	Json::Value getArea();
	void setUpArea(Json::Value& v);
	void setUpPlace(Json::Value& v);
	void setAngle(float angle);
	void centerView();
	 
protected:
	GtkAccelGroup *m_ag;
	OsmGpsMap *m_map;
    OsmGpsMapLayer *m_osd;
    OsmGpsMapTrack *m_rightclicktrack;
    OsmGpsMapTrack *m_placeTrack;
	const char *m_repo_uri;
    char *m_cachedir, *m_cachebasedir;
    GError *m_error = NULL;
    GOptionContext *m_context;
	OsmGpsMapPolygon* m_poly;
	OsmGpsMapTrack* m_polytrack;
	GtkSpinButton*  m_angle;
	Json::Value		m_area;
	Json::Value		m_place;
	ZoneTab*		m_zone;
	bool			m_init;
private:
	friend gboolean on_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data);
	friend gboolean on_save (GtkWidget *widget, GdkEventButton *event, gpointer user_data);
};

#endif // _MAP_VIEWER_H_

