/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-  */
/*
 * os.h
 * Copyright (C) 2016 Fran??ois Gautrais <francois@gautrais.eu>
 *
 * histodex is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * histodex is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _OS_H_
#define _OS_H_

#include "main.h"

class OS
{
public:
	static void mkdir(const std::string& dir);
	static std::string pwd();
	static void copy(const std::string& src, const std::string& dst);
	static std::string concatPath(const std::string& src, const std::string& dst);

	class Path 
	{
		public:
			Path (const std::string& file);
			virtual ~Path(){}

			const std::string& getDir() const {return m_dir;}
			const std::string& getName() const {return m_name;}
			const std::string& getExt() const {return m_ext;}
			std::string getFileName();
			void print();

			
			std::string m_dir;
			std::string m_name;
			std::string m_ext;
			std::string m_pwd;
		protected:
	};
 	 
protected:

private:

};

#endif // _OS_H_

