/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-  */
/*
 * stage-tab.h
 * Copyright (C) 2017 Unknown <francois@gautrais.eu>
 *
 * histodexc is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * histodexc is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _STAGE_TAB_H_
#define _STAGE_TAB_H_
class Stage;
#include "tab.h"
class ResourceTab;

class StageTab: public Tab 
{
	public:
							StageTab(GtkWidget *window, GtkBuilder *builder, ResourceTab* tab);
		virtual				~StageTab();
		
		virtual void		write(const std::string& file);
		virtual Data&		getTab(bool& genFinal);

		void				on_save_clicked();
		void				on_select(); 
		void				on_select_res(); 
		void				on_click_res();
		void				open(Json::Value& val);
		Json::Value			getJson(bool genFinal=false);
		void				setNStage(int n);
		void				insert(int n,  Stage* ra);
		void				removeLast();
		void				setupTab(Data& s);
		std::vector<Stage>& getStages() { return m_stages; }
	protected:
		GtkBox*				m_root;
		GtkEntry*			m_resource;
		GtkTreeView*		m_list;
		GtkListStore*	    m_listStore;
		GtkTreeView*		m_listRes;
		GtkListStore*	    m_listResStore;
		GtkButton*			m_devRes;
		GtkSpinButton*		m_nRes;
		GtkSwitch*			m_transition;
		ResourceTab*   		m_resTab;

		std::vector<Stage>  m_stages;
		volatile bool		m_lock;
	private:

};

#endif // _STAGE_TAB_H_

