/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-  */
/*
 * stage.h
 * Copyright (C) 2016 Fran??ois Gautrais <francois@gautrais.eu>
 *
 * histodex is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * histodex is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _STAGE_H_
#define _STAGE_H_

#include <iostream>
#include <json/json.h>
#include "data.h"

class Stage : public Data
{
	public:
							Stage();
							Stage(Json::Value v);
		virtual				~Stage();
		 
		const std::string&  getResource();
		void				setResource(const std::string& r);
		int					getStage();
		void				setStage(int stage);
		int					getNRes();
		void				setNRes(int res);
	
		Json::Value			getJson(bool b=false);
		void				set(Json::Value& v);
		void				setTransition(bool b);
		bool				getTransition();
		static Stage& 		cast(Data& d);
	protected:
		
		int					m_stage;
		int					m_nRes;
		std::string			m_resource;
		bool				m_transition;
		 
	private:

};

#endif // _STAGE_H_

